--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11PBECipher.java	1970-01-01 01:00:00.000000000 +0100
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11PBECipher.java	2022-10-19 11:43:33.835267926 +0200
@@ -0,0 +1,200 @@
+/*
+ * Copyright (c) 2022, Red Hat, Inc.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package sun.security.pkcs11;
+
+import java.security.AlgorithmParameters;
+import java.security.Key;
+import java.security.InvalidAlgorithmParameterException;
+import java.security.InvalidKeyException;
+import java.security.NoSuchAlgorithmException;
+import java.security.SecureRandom;
+import java.security.spec.AlgorithmParameterSpec;
+import java.security.spec.InvalidKeySpecException;
+import javax.crypto.BadPaddingException;
+import javax.crypto.CipherSpi;
+import javax.crypto.IllegalBlockSizeException;
+import javax.crypto.NoSuchPaddingException;
+import javax.crypto.ShortBufferException;
+import javax.crypto.spec.PBEKeySpec;
+
+import static sun.security.pkcs11.wrapper.PKCS11Constants.*;
+import sun.security.jca.JCAUtil;
+import sun.security.pkcs11.wrapper.PKCS11Exception;
+import sun.security.util.PBEUtil;
+
+final class P11PBECipher extends CipherSpi {
+
+    private static final int DEFAULT_SALT_LENGTH = 20;
+    private static final int DEFAULT_COUNT = 4096;
+
+    private final Token token;
+    private final String pbeAlg;
+    private final P11Cipher cipher;
+    private final int blkSize;
+    private final int keyLen;
+    private final PBEUtil.PBES2Helper pbes2Helper = new PBEUtil.PBES2Helper(
+            DEFAULT_SALT_LENGTH, DEFAULT_COUNT);
+
+    P11PBECipher(Token token, String pbeAlg, long cipherMech)
+                    throws PKCS11Exception, NoSuchAlgorithmException {
+        super();
+        String cipherTrans;
+        if (cipherMech == CKM_AES_CBC_PAD || cipherMech == CKM_AES_CBC) {
+            cipherTrans = "AES/CBC/PKCS5Padding";
+        } else {
+            throw new NoSuchAlgorithmException(
+                    "Cipher transformation not supported.");
+        }
+        cipher = new P11Cipher(token, cipherTrans, cipherMech);
+        blkSize = cipher.engineGetBlockSize();
+        assert P11Util.kdfDataMap.get(pbeAlg) != null;
+        keyLen = P11Util.kdfDataMap.get(pbeAlg).keyLen;
+        this.pbeAlg = pbeAlg;
+        this.token = token;
+    }
+
+    // see JCE spec
+    @Override
+    protected void engineSetMode(String mode)
+            throws NoSuchAlgorithmException {
+        cipher.engineSetMode(mode);
+    }
+
+    // see JCE spec
+    @Override
+    protected void engineSetPadding(String padding)
+            throws NoSuchPaddingException {
+        cipher.engineSetPadding(padding);
+    }
+
+    // see JCE spec
+    @Override
+    protected int engineGetBlockSize() {
+        return cipher.engineGetBlockSize();
+    }
+
+    // see JCE spec
+    @Override
+    protected int engineGetOutputSize(int inputLen) {
+        return cipher.engineGetOutputSize(inputLen);
+    }
+
+    // see JCE spec
+    @Override
+    protected byte[] engineGetIV() {
+        return cipher.engineGetIV();
+    }
+
+    // see JCE spec
+    @Override
+    protected AlgorithmParameters engineGetParameters() {
+        return pbes2Helper.getAlgorithmParameters(
+                blkSize, pbeAlg, null, JCAUtil.getSecureRandom());
+    }
+
+    // see JCE spec
+    @Override
+    protected void engineInit(int opmode, Key key,
+            SecureRandom random) throws InvalidKeyException {
+        try {
+            engineInit(opmode, key, (AlgorithmParameterSpec) null, random);
+        } catch (InvalidAlgorithmParameterException e) {
+            throw new InvalidKeyException("requires PBE parameters", e);
+        }
+    }
+
+    // see JCE spec
+    @Override
+    protected void engineInit(int opmode, Key key,
+            AlgorithmParameterSpec params, SecureRandom random)
+                    throws InvalidKeyException,
+                    InvalidAlgorithmParameterException {
+
+        PBEKeySpec pbeSpec = pbes2Helper.getPBEKeySpec(blkSize, keyLen,
+                opmode, key, params, random);
+
+        Key derivedKey;
+        try {
+            derivedKey = P11SecretKeyFactory.derivePBEKey(
+                    token, pbeSpec, pbeAlg);
+        } catch (InvalidKeySpecException e) {
+            throw new InvalidKeyException(e);
+        }
+        cipher.engineInit(opmode, derivedKey, pbes2Helper.getIvSpec(), random);
+    }
+
+    // see JCE spec
+    @Override
+    protected void engineInit(int opmode, Key key,
+            AlgorithmParameters params, SecureRandom random)
+                    throws InvalidKeyException,
+                    InvalidAlgorithmParameterException {
+        engineInit(opmode, key, PBEUtil.PBES2Helper.getParameterSpec(params),
+                random);
+    }
+
+    // see JCE spec
+    @Override
+    protected byte[] engineUpdate(byte[] input, int inputOffset,
+            int inputLen) {
+        return cipher.engineUpdate(input, inputOffset, inputLen);
+    }
+
+    // see JCE spec
+    @Override
+    protected int engineUpdate(byte[] input, int inputOffset,
+            int inputLen, byte[] output, int outputOffset)
+                    throws ShortBufferException {
+        return cipher.engineUpdate(input, inputOffset, inputLen,
+                output, outputOffset);
+    }
+
+    // see JCE spec
+    @Override
+    protected byte[] engineDoFinal(byte[] input, int inputOffset,
+            int inputLen)
+                    throws IllegalBlockSizeException, BadPaddingException {
+        return cipher.engineDoFinal(input, inputOffset, inputLen);
+    }
+
+    // see JCE spec
+    @Override
+    protected int engineDoFinal(byte[] input, int inputOffset,
+            int inputLen, byte[] output, int outputOffset)
+                    throws ShortBufferException, IllegalBlockSizeException,
+                    BadPaddingException {
+        return cipher.engineDoFinal(input, inputOffset, inputLen, output,
+                outputOffset);
+    }
+
+    // see JCE spec
+    @Override
+    protected int engineGetKeySize(Key key)
+            throws InvalidKeyException {
+        return cipher.engineGetKeySize(key);
+    }
+
+}
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11SecretKeyFactory.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11SecretKeyFactory.java	2022-10-19 11:43:33.835267926 +0200
@@ -31,6 +31,7 @@
 import java.security.spec.*;
 
 import javax.crypto.*;
+import javax.crypto.interfaces.PBEKey;
 import javax.crypto.spec.*;
 
 import static sun.security.pkcs11.TemplateManager.*;
@@ -194,6 +195,128 @@
         return p11Key;
     }
 
+    static P11Key derivePBEKey(Token token, PBEKeySpec keySpec, String algo)
+            throws InvalidKeySpecException {
+        token.ensureValid();
+        if (keySpec == null) {
+            throw new InvalidKeySpecException("PBEKeySpec must not be null");
+        }
+        Session session = null;
+        try {
+            session = token.getObjSession();
+            P11Util.KDFData kdfData = P11Util.kdfDataMap.get(algo);
+            CK_MECHANISM ckMech;
+            char[] password = keySpec.getPassword();
+            byte[] salt = keySpec.getSalt();
+            int itCount = keySpec.getIterationCount();
+            int keySize = keySpec.getKeyLength();
+            if (kdfData.keyLen != -1) {
+                if (keySize == 0) {
+                    keySize = kdfData.keyLen;
+                } else if (keySize != kdfData.keyLen) {
+                    throw new InvalidKeySpecException(
+                            "Key length is invalid for " + algo);
+                }
+            }
+
+            if (kdfData.kdfMech == CKM_PKCS5_PBKD2) {
+                CK_VERSION p11Ver = token.p11.getInfo().cryptokiVersion;
+                if (P11Util.isNSS(token) || p11Ver.major < 2 ||
+                        p11Ver.major == 2 && p11Ver.minor < 40) {
+                    // NSS keeps using the old structure beyond PKCS #11 v2.40
+                    ckMech = new CK_MECHANISM(kdfData.kdfMech,
+                            new CK_PKCS5_PBKD2_PARAMS(password, salt,
+                                    itCount, kdfData.prfMech));
+                } else {
+                    ckMech = new CK_MECHANISM(kdfData.kdfMech,
+                            new CK_PKCS5_PBKD2_PARAMS2(password, salt,
+                                    itCount, kdfData.prfMech));
+                }
+            } else {
+                // PKCS #12 "General Method" PBKD (RFC 7292, Appendix B.2)
+                if (P11Util.isNSS(token)) {
+                    // According to PKCS #11, "password" in CK_PBE_PARAMS has
+                    // a CK_UTF8CHAR_PTR type. This suggests that it is encoded
+                    // in UTF-8. However, NSS expects the password to be encoded
+                    // as BMPString with a NULL terminator when C_GenerateKey
+                    // is called for a PKCS #12 "General Method" derivation
+                    // (see RFC 7292, Appendix B.1).
+                    //
+                    // The char size in Java is 2 bytes. When a char is
+                    // converted to a CK_UTF8CHAR, the high-order byte is
+                    // discarded (see jCharArrayToCKUTF8CharArray in
+                    // p11_util.c). In order to have a BMPString passed to
+                    // C_GenerateKey, we need to account for that and expand:
+                    // the high and low parts of each char are split into 2
+                    // chars. As an example, this is the transformation for
+                    // a NULL terminated password "a":
+                    // char[]    =>        [   0x0061,          0x0000     ]
+                    //                          /    \           /    \
+                    // Expansion =>       [0x0000, 0x0061, 0x0000, 0x0000]
+                    //                         |       |       |       |
+                    // BMPString =>       [  0x00,   0x61,   0x00,   0x00]
+                    //
+                    int inputLength = (password == null) ? 0 : password.length;
+                    char[] expPassword = new char[inputLength * 2 + 2];
+                    for (int i = 0, j = 0; i < inputLength; i++, j += 2) {
+                        expPassword[j] = (char) ((password[i] >>> 8) & 0xFF);
+                        expPassword[j + 1] = (char) (password[i] & 0xFF);
+                    }
+                    password = expPassword;
+                }
+                ckMech = new CK_MECHANISM(kdfData.kdfMech,
+                        new CK_PBE_PARAMS(password, salt, itCount));
+            }
+
+            long keyType = getKeyType(kdfData.keyAlgo);
+            CK_ATTRIBUTE[] attrs = new CK_ATTRIBUTE[
+                    switch (kdfData.op) {
+                        case ENCRYPTION, AUTHENTICATION -> 4;
+                        case GENERIC -> 5;
+                    }];
+            attrs[0] = new CK_ATTRIBUTE(CKA_CLASS, CKO_SECRET_KEY);
+            attrs[1] = new CK_ATTRIBUTE(CKA_VALUE_LEN, keySize >> 3);
+            attrs[2] = new CK_ATTRIBUTE(CKA_KEY_TYPE, keyType);
+            switch (kdfData.op) {
+                case ENCRYPTION -> attrs[3] = CK_ATTRIBUTE.ENCRYPT_TRUE;
+                case AUTHENTICATION -> attrs[3] = CK_ATTRIBUTE.SIGN_TRUE;
+                case GENERIC -> {
+                    attrs[3] = CK_ATTRIBUTE.ENCRYPT_TRUE;
+                    attrs[4] = CK_ATTRIBUTE.SIGN_TRUE;
+                }
+            }
+            CK_ATTRIBUTE[] attr = token.getAttributes(
+                    O_GENERATE, CKO_SECRET_KEY, keyType, attrs);
+            long keyID = token.p11.C_GenerateKey(session.id(), ckMech, attr);
+            return (P11Key)P11Key.secretKey(
+                    session, keyID, kdfData.keyAlgo, keySize, attr);
+        } catch (PKCS11Exception e) {
+            throw new InvalidKeySpecException("Could not create key", e);
+        } finally {
+            token.releaseSession(session);
+        }
+    }
+
+    static P11Key derivePBEKey(Token token, PBEKey key, String algo)
+            throws InvalidKeyException {
+        token.ensureValid();
+        if (key == null) {
+            throw new InvalidKeyException("PBEKey must not be null");
+        }
+        P11Key p11Key = token.secretCache.get(key);
+        if (p11Key != null) {
+            return p11Key;
+        }
+        try {
+            p11Key = derivePBEKey(token, new PBEKeySpec(key.getPassword(),
+                    key.getSalt(), key.getIterationCount()), algo);
+        } catch (InvalidKeySpecException e) {
+            throw new InvalidKeyException(e);
+        }
+        token.secretCache.put(key, p11Key);
+        return p11Key;
+    }
+
     static void fixDESParity(byte[] key, int offset) {
         for (int i = 0; i < 8; i++) {
             int b = key[offset] & 0xfe;
@@ -320,6 +443,9 @@
                 keySpec = new SecretKeySpec(keyBytes, "DESede");
                 return engineGenerateSecret(keySpec);
             }
+        } else if (keySpec instanceof PBEKeySpec) {
+            return (SecretKey)derivePBEKey(token,
+                    (PBEKeySpec)keySpec, algorithm);
         }
         throw new InvalidKeySpecException
                 ("Unsupported spec: " + keySpec.getClass().getName());
@@ -373,6 +499,9 @@
     // see JCE spec
     protected SecretKey engineTranslateKey(SecretKey key)
             throws InvalidKeyException {
+        if (key instanceof PBEKey) {
+            return (SecretKey)derivePBEKey(token, (PBEKey)key, algorithm);
+        }
         return (SecretKey)convertKey(token, key, algorithm);
     }
 
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11Util.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/P11Util.java	2022-10-19 11:43:33.835267926 +0200
@@ -27,6 +27,10 @@
 
 import java.math.BigInteger;
 import java.security.*;
+import java.util.HashMap;
+import java.util.Map;
+
+import static sun.security.pkcs11.wrapper.PKCS11Constants.*;
 
 /**
  * Collection of static utility methods.
@@ -40,10 +44,106 @@
 
     private static volatile Provider sun, sunRsaSign, sunJce;
 
+    // Used by PBE
+    static final class KDFData {
+        public enum Operation {ENCRYPTION, AUTHENTICATION, GENERIC}
+        public long kdfMech;
+        public long prfMech;
+        public String keyAlgo;
+        public int keyLen;
+        public Operation op;
+        KDFData(long kdfMech, long prfMech, String keyAlgo,
+                int keyLen, Operation op) {
+            this.kdfMech = kdfMech;
+            this.prfMech = prfMech;
+            this.keyAlgo = keyAlgo;
+            this.keyLen = keyLen;
+            this.op = op;
+        }
+
+        public static void addPbkdf2Data(String algo, long kdfMech,
+                                         long prfMech) {
+            kdfDataMap.put(algo, new KDFData(kdfMech, prfMech,
+                    "Generic", -1, Operation.GENERIC));
+        }
+
+        public static void addPbkdf2AesData(String algo, long kdfMech,
+                                            long prfMech, int keyLen) {
+            kdfDataMap.put(algo, new KDFData(kdfMech, prfMech,
+                    "AES", keyLen, Operation.ENCRYPTION));
+        }
+
+        public static void addPkcs12KDData(String algo, long kdfMech,
+                                         int keyLen) {
+            kdfDataMap.put(algo, new KDFData(kdfMech, -1,
+                    "Generic", keyLen, Operation.AUTHENTICATION));
+        }
+    }
+
+    static final Map<String, KDFData> kdfDataMap = new HashMap<>();
+
+    static {
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA1AndAES_128",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA1, 128);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA224AndAES_128",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA224, 128);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA256AndAES_128",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA256, 128);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA384AndAES_128",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA384, 128);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA512AndAES_128",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA512, 128);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA1AndAES_256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA1, 256);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA224AndAES_256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA224, 256);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA256AndAES_256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA256, 256);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA384AndAES_256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA384, 256);
+        KDFData.addPbkdf2AesData("PBEWithHmacSHA512AndAES_256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA512, 256);
+
+        KDFData.addPbkdf2Data("PBKDF2WithHmacSHA1",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA1);
+        KDFData.addPbkdf2Data("PBKDF2WithHmacSHA224",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA224);
+        KDFData.addPbkdf2Data("PBKDF2WithHmacSHA256",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA256);
+        KDFData.addPbkdf2Data("PBKDF2WithHmacSHA384",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA384);
+        KDFData.addPbkdf2Data("PBKDF2WithHmacSHA512",
+                CKM_PKCS5_PBKD2, CKP_PKCS5_PBKD2_HMAC_SHA512);
+
+        KDFData.addPkcs12KDData("HmacPBESHA1",
+                CKM_PBA_SHA1_WITH_SHA1_HMAC, 160);
+        KDFData.addPkcs12KDData("HmacPBESHA224",
+                CKM_NSS_PKCS12_PBE_SHA224_HMAC_KEY_GEN, 224);
+        KDFData.addPkcs12KDData("HmacPBESHA256",
+                CKM_NSS_PKCS12_PBE_SHA256_HMAC_KEY_GEN, 256);
+        KDFData.addPkcs12KDData("HmacPBESHA384",
+                CKM_NSS_PKCS12_PBE_SHA384_HMAC_KEY_GEN, 384);
+        KDFData.addPkcs12KDData("HmacPBESHA512",
+                CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN, 512);
+        KDFData.addPkcs12KDData("HmacPBESHA512/224",
+                CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN, 512);
+        KDFData.addPkcs12KDData("HmacPBESHA512/256",
+                CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN, 512);
+    }
+
     private P11Util() {
         // empty
     }
 
+    static boolean isNSS(Token token) {
+        char[] tokenLabel = token.tokenInfo.label;
+        if (tokenLabel != null && tokenLabel.length >= 3) {
+            return (tokenLabel[0] == 'N' && tokenLabel[1] == 'S'
+                    && tokenLabel[2] == 'S');
+        }
+        return false;
+    }
+
     static Provider getSunProvider() {
         Provider p = sun;
         if (p == null) {
